/*
 * 创客反馈
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserBackController : BaseController
    {
        public UserBackController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 创客反馈列表

        /// <summary>
        /// 根据条件查询创客反馈列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserBack data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            string Condition = "";
            Condition += "IsPhoneCallBack:\"" + data.IsPhoneCallBack + "\",";
Condition += "BackStatus:\"" + data.BackStatus + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询创客反馈列表

        /// <summary>
        /// 创客反馈列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserBack data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("CreateDate", "3"); //时间
Fields.Add("IsPhoneCallBack", "1"); //是否需要电话回复
Fields.Add("BackStatus", "1"); //回复状态

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserBack", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["UserId"] = RelationClass.GetUsersInfo(int.Parse(dic["UserId"].ToString()));
dic["IsPhoneCallBackName"] = dic["IsPhoneCallBack"].ToString() == "1" ? "是" : "否";
dic["BackKind"] = RelationClass.GetUserBackKindInfo(int.Parse(dic["BackKind"].ToString()));

            }
            return Json(obj);
        }

        #endregion

        #region 增加创客反馈

        /// <summary>
        /// 增加或修改创客反馈信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加创客反馈

        /// <summary>
        /// 增加或修改创客反馈信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserBack data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            
            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("UserBack", Fields, 0);
            AddSysLog(data.Id.ToString(), "UserBack", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改创客反馈

        /// <summary>
        /// 增加或修改创客反馈信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            UserBack editData = db.UserBack.FirstOrDefault(m => m.Id == Id) ?? new UserBack();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改创客反馈

        /// <summary>
        /// 增加或修改创客反馈信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserBack data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            
            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserBack", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"UserBack","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除创客反馈信息

        /// <summary>
        /// 删除创客反馈信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"UserBack","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserBack", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"UserBack","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserBack", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"UserBack","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserBack", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("UserBack", Sort, Id);
            
            AddSysLog(Id.ToString(), "UserBack", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.UserBack.Add(new UserBack()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "UserBack", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserBack data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
Fields.Add("IsPhoneCallBack", "1"); //是否需要电话回复
Fields.Add("BackStatus", "1"); //回复状态

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserBack", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["UserId"] = RelationClass.GetUsersInfo(int.Parse(dic["UserId"].ToString()));
dic["IsPhoneCallBackName"] = dic["IsPhoneCallBack"].ToString() == "1" ? "是" : "否";
dic["BackKind"] = RelationClass.GetUserBackKindInfo(int.Parse(dic["BackKind"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserBack", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
